import * as i0 from '@angular/core';
import { Injectable, Component, ChangeDetectionStrategy, Input, EventEmitter, Output, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i3 from '@angular/forms';
import { FormControl, FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i2$2 from 'ng-zorro-antd/grid';
import { NzGridModule } from 'ng-zorro-antd/grid';
import * as i4 from 'ng-zorro-antd/button';
import { NzButtonModule } from 'ng-zorro-antd/button';
import * as i1 from 'ng-zorro-antd/icon';
import { NzIconModule } from 'ng-zorro-antd/icon';
import { DownloadOutline, EditOutline, PlusOutline, DeleteOutline, WarningOutline } from '@ant-design/icons-angular/icons';
import { finalize, debounceTime, distinctUntilChanged, tap } from 'rxjs/operators';
import * as i1$1 from 'ng-zorro-antd/i18n';
import { en_US } from 'ng-zorro-antd/i18n';
import * as i5 from 'ng-zorro-antd/core/transition-patch';
import * as i6 from 'ng-zorro-antd/core/wave';
import * as i8$1 from 'ng-zorro-antd/input';
import { NzInputModule } from 'ng-zorro-antd/input';
import * as i9 from 'ng-zorro-antd/spin';
import { NzSpinModule } from 'ng-zorro-antd/spin';
import * as i10$1 from 'ng-zorro-antd/table';
import { NzTableModule } from 'ng-zorro-antd/table';
import * as i7 from 'ng-zorro-antd/menu';
import * as i8 from 'ng-zorro-antd/dropdown';
import { NzDropDownModule } from 'ng-zorro-antd/dropdown';
import * as i10 from 'ng-zorro-antd/switch';
import { NzSwitchModule } from 'ng-zorro-antd/switch';
import { NzPaginationModule } from 'ng-zorro-antd/pagination';
import * as i2$1 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i3$1 from 'ng-zorro-antd/page-header';
import { NzPageHeaderModule } from 'ng-zorro-antd/page-header';
import * as i4$1 from 'ng-zorro-antd/tabs';
import { NzTabsModule } from 'ng-zorro-antd/tabs';
import * as i5$1 from 'ng-zorro-antd/breadcrumb';
import { NzBreadCrumbModule } from 'ng-zorro-antd/breadcrumb';
import * as i6$1 from 'ng-zorro-antd/tag';
import { NzTagModule } from 'ng-zorro-antd/tag';
import { NzAnchorModule } from 'ng-zorro-antd/anchor';
import { NzCardModule } from 'ng-zorro-antd/card';
import { NzCascaderModule } from 'ng-zorro-antd/cascader';
import { NzCollapseModule } from 'ng-zorro-antd/collapse';
import { NzDividerModule } from 'ng-zorro-antd/divider';
import { NzDrawerModule } from 'ng-zorro-antd/drawer';
import { NzFormModule } from 'ng-zorro-antd/form';
import { NzInputNumberModule } from 'ng-zorro-antd/input-number';
import { NzMessageModule } from 'ng-zorro-antd/message';
import { NzModalModule } from 'ng-zorro-antd/modal';
import { NzRadioModule } from 'ng-zorro-antd/radio';
import { NzResultModule } from 'ng-zorro-antd/result';
import { NzSelectModule } from 'ng-zorro-antd/select';
import { NzSpaceModule } from 'ng-zorro-antd/space';
import { NzToolTipModule } from 'ng-zorro-antd/tooltip';
import { NzTypographyModule } from 'ng-zorro-antd/typography';
import { HttpErrorResponse } from '@angular/common/http';

var ResponseStatus;
(function (ResponseStatus) {
    ResponseStatus["Success"] = "SUCCESS";
    ResponseStatus["Failed"] = "FAILED";
})(ResponseStatus || (ResponseStatus = {}));

class UmbrellaLibraryService {
    constructor() { }
    isSuccessfulResponse(response) {
        return response.responseStatus === 'SUCCESS';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryService, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryService, providedIn: 'root' }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class UmbrellaLibraryComponent {
    constructor() { }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: UmbrellaLibraryComponent, selector: "lib-umbrella-library", ngImport: i0, template: ` <p>umbrella-library is amazing!</p> `, isInline: true }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-umbrella-library', template: ` <p>umbrella-library is amazing!</p> ` }]
        }], ctorParameters: function () { return []; } });

var DataTableColumnFormatType;
(function (DataTableColumnFormatType) {
    DataTableColumnFormatType["date"] = "date";
    DataTableColumnFormatType["boolean"] = "boolean";
    DataTableColumnFormatType["label"] = "label";
    DataTableColumnFormatType["statusToggle"] = "statusToggle";
    DataTableColumnFormatType["nestedAttribute"] = "nestedAttribute";
    DataTableColumnFormatType["menuDropdownActions"] = "menuDropdownActions";
    DataTableColumnFormatType["templateRef"] = "templateRef";
    DataTableColumnFormatType["contacts"] = "contacts";
})(DataTableColumnFormatType || (DataTableColumnFormatType = {}));

/**
 *
 * @param object a table data record
 * @param nestedAttributePath the path of a nested attribute to display
 * @returns the value of a sub object located at the nested path of the input object
 * @example
 * ```ts
 * const exObj = {fleet: {vehicleGroup: {id: 1, name: 'v group 1'}}};
 * const nestedValue = getNestedAttribute(exObj, 'fleet.vehicleGroup.name');
 * console.log(nestedValue);
 * // v group 1
 * ```
 */
function getNestedAttribute(object, nestedAttributePath) {
    const nestedAttributes = nestedAttributePath.split('.');
    let nestedAttributeValue = object;
    for (let nestedAttribute of nestedAttributes) {
        if (nestedAttributeValue[nestedAttribute]) {
            nestedAttributeValue = nestedAttributeValue[nestedAttribute];
        }
        else {
            nestedAttributeValue = undefined;
            break;
        }
    }
    return nestedAttributeValue;
}

class CustomDataTableCellComponent {
    constructor(cdr, library) {
        this.cdr = cdr;
        this.library = library;
        this.dataTableColumnFormatType = DataTableColumnFormatType;
        this.getNestedAttribute = getNestedAttribute;
    }
    onStatusToggleClick(event, column, record) {
        if (column.format?.type === DataTableColumnFormatType.statusToggle) {
            this.loadingStatusToggleRecordId = record.id;
            column.format
                .action(record.id, { ...record, status: !record.status })
                .pipe(finalize(() => {
                this.loadingStatusToggleRecordId = -1;
                this.cdr.markForCheck();
            }))
                .subscribe((response) => {
                if (!this.library.isSuccessfulResponse(response)) {
                    event.preventDefault();
                }
                else {
                    record.status = !record.status;
                }
            });
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CustomDataTableCellComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: UmbrellaLibraryService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: { column: "column", record: "record" }, ngImport: i0, template: "<ng-container *ngIf=\"column.format\"\n    [ngSwitch]=\"column.format.type\">\n  <!-- Date -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.date\">\n    {{ record[column.field] | date: 'd MMM yyyy' }}\n  </span>\n  <!-- Boolean -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.boolean\">\n    {{ record[column.field] ? column.format.true : column.format.false }}\n  </span>\n  <!-- Label -->\n  <span *ngSwitchCase=\"'label'\">\n    <label\n        class=\"x-table-label x-table-label-{{ column.format.labels[record[column.field]].labelColor }}\">\n      {{ column.format.labels[record[column.field]].labelText }}\n    </label>\n  </span>\n  <!-- Contacts -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.contacts\">\n    <span *ngIf=\"!record[column.field].length\">\n      {{ record[column.field].firstName }}\n      {{ record[column.field].lastName }}\n    </span>\n    <span *ngFor=\"let c of record[column.field]; last as isLast\"\n        class=\"capitalize\">\n      {{ c.firstName }} {{ c.lastName }}<br *ngIf=\"!isLast\" />\n    </span>\n  </span>\n  <!-- Status -->\n  <nz-switch *ngSwitchCase=\"dataTableColumnFormatType.statusToggle\"\n      [nzLoading]=\"loadingStatusToggleRecordId === record.id\"\n      (click)=\"onStatusToggleClick($event, column, record)\"\n      [ngModel]=\"record.status\"></nz-switch>\n  <!-- Nested Attribute -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.nestedAttribute\">\n    {{ getNestedAttribute(record, column.field) }}\n  </span>\n  <!-- Edit, Delete and more Action Buttons -->\n  <ng-container *ngSwitchCase=\"dataTableColumnFormatType.menuDropdownActions\">\n    <div class=\"x-data-table-dropdown-menu-cell hidden\"\n        *ngIf=\"column.format?.dropdownActionItems?.length\">\n      <button nz-button\n          nzNoAnimation\n          nz-dropdown\n          [nzDropdownMenu]=\"menu\"\n          style=\"border: none; padding: 0\">\n        <i nz-icon\n            nzType=\"ellipsis\"\n            nzTheme=\"outline\"\n            style=\"font-size: 20px; vertical-align: top\">\n        </i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li *ngFor=\"let dropdownItem of column.format.dropdownActionItems\"\n              nz-menu-item\n              [nzDisabled]=\"dropdownItem.disabled\"\n              [ngClass]=\"{ 'no-pointer': dropdownItem.disabled }\"\n              (click)=\"dropdownItem.action(record)\">\n            <span>\n              <i nz-icon\n                  [nzType]=\"dropdownItem.nzIconName\"></i>\n              {{ dropdownItem.text }}\n            </span>\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </div>\n  </ng-container>\n</ng-container>\n", styles: [".x-data-table-dropdown-menu-cell{display:inline-flex!important}.x-data-table-dropdown-menu-cell button{border:1.5px solid rgba(0,0,0,.1490196078);width:32px}label.x-table-label{border-radius:15px;padding:5px 10px}label.x-table-label.x-table-label-red{background-color:var(--x-color-danger-surface);color:var(--x-color-danger-main)}label.x-table-label.x-table-label-green{background-color:var(--x-color-success-surface);color:var(--x-color-success-main)}label.x-table-label.x-table-label-gray{background-color:var(--x-color-neutral-focused);color:var(--x-color-neutral-main)}::ng-deep .no-pointer{pointer-events:none;cursor:default}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgSwitch, selector: "[ngSwitch]", inputs: ["ngSwitch"] }, { kind: "directive", type: i2.NgSwitchCase, selector: "[ngSwitchCase]", inputs: ["ngSwitchCase"] }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "component", type: i4.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i5.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i6.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "directive", type: i7.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { kind: "component", type: i7.NzMenuItemComponent, selector: "[nz-menu-item]", inputs: ["nzPaddingLeft", "nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter"], exportAs: ["nzMenuItem"] }, { kind: "directive", type: i8.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { kind: "component", type: i8.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }, { kind: "directive", type: i8.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { kind: "directive", type: i1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { kind: "component", type: i10.NzSwitchComponent, selector: "nz-switch", inputs: ["nzLoading", "nzDisabled", "nzControl", "nzCheckedChildren", "nzUnCheckedChildren", "nzSize", "nzId"], exportAs: ["nzSwitch"] }, { kind: "pipe", type: i2.DatePipe, name: "date" }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: CustomDataTableCellComponent, decorators: [{
            type: Component,
            args: [{ selector: 'x-custom-data-table-cell', changeDetection: ChangeDetectionStrategy.OnPush, template: "<ng-container *ngIf=\"column.format\"\n    [ngSwitch]=\"column.format.type\">\n  <!-- Date -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.date\">\n    {{ record[column.field] | date: 'd MMM yyyy' }}\n  </span>\n  <!-- Boolean -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.boolean\">\n    {{ record[column.field] ? column.format.true : column.format.false }}\n  </span>\n  <!-- Label -->\n  <span *ngSwitchCase=\"'label'\">\n    <label\n        class=\"x-table-label x-table-label-{{ column.format.labels[record[column.field]].labelColor }}\">\n      {{ column.format.labels[record[column.field]].labelText }}\n    </label>\n  </span>\n  <!-- Contacts -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.contacts\">\n    <span *ngIf=\"!record[column.field].length\">\n      {{ record[column.field].firstName }}\n      {{ record[column.field].lastName }}\n    </span>\n    <span *ngFor=\"let c of record[column.field]; last as isLast\"\n        class=\"capitalize\">\n      {{ c.firstName }} {{ c.lastName }}<br *ngIf=\"!isLast\" />\n    </span>\n  </span>\n  <!-- Status -->\n  <nz-switch *ngSwitchCase=\"dataTableColumnFormatType.statusToggle\"\n      [nzLoading]=\"loadingStatusToggleRecordId === record.id\"\n      (click)=\"onStatusToggleClick($event, column, record)\"\n      [ngModel]=\"record.status\"></nz-switch>\n  <!-- Nested Attribute -->\n  <span *ngSwitchCase=\"dataTableColumnFormatType.nestedAttribute\">\n    {{ getNestedAttribute(record, column.field) }}\n  </span>\n  <!-- Edit, Delete and more Action Buttons -->\n  <ng-container *ngSwitchCase=\"dataTableColumnFormatType.menuDropdownActions\">\n    <div class=\"x-data-table-dropdown-menu-cell hidden\"\n        *ngIf=\"column.format?.dropdownActionItems?.length\">\n      <button nz-button\n          nzNoAnimation\n          nz-dropdown\n          [nzDropdownMenu]=\"menu\"\n          style=\"border: none; padding: 0\">\n        <i nz-icon\n            nzType=\"ellipsis\"\n            nzTheme=\"outline\"\n            style=\"font-size: 20px; vertical-align: top\">\n        </i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li *ngFor=\"let dropdownItem of column.format.dropdownActionItems\"\n              nz-menu-item\n              [nzDisabled]=\"dropdownItem.disabled\"\n              [ngClass]=\"{ 'no-pointer': dropdownItem.disabled }\"\n              (click)=\"dropdownItem.action(record)\">\n            <span>\n              <i nz-icon\n                  [nzType]=\"dropdownItem.nzIconName\"></i>\n              {{ dropdownItem.text }}\n            </span>\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </div>\n  </ng-container>\n</ng-container>\n", styles: [".x-data-table-dropdown-menu-cell{display:inline-flex!important}.x-data-table-dropdown-menu-cell button{border:1.5px solid rgba(0,0,0,.1490196078);width:32px}label.x-table-label{border-radius:15px;padding:5px 10px}label.x-table-label.x-table-label-red{background-color:var(--x-color-danger-surface);color:var(--x-color-danger-main)}label.x-table-label.x-table-label-green{background-color:var(--x-color-success-surface);color:var(--x-color-success-main)}label.x-table-label.x-table-label-gray{background-color:var(--x-color-neutral-focused);color:var(--x-color-neutral-main)}::ng-deep .no-pointer{pointer-events:none;cursor:default}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: UmbrellaLibraryService }]; }, propDecorators: { column: [{
                type: Input
            }], record: [{
                type: Input
            }] } });

class DataTableComponent {
    constructor(cdr, i18n) {
        this.cdr = cdr;
        this.i18n = i18n;
        this.showDownloadButton = false;
        this.downloadFileName = 'DataTable_DownloadedCSVData';
        this.totalRecordsCount = 0;
        this.pageSize = 10;
        this.loading = false;
        this.selectable = false;
        this.selectedRecordsSet = new Set();
        this.readonly = false;
        this.searchable = true;
        this.width = 'normal';
        this.fetchRecords = new EventEmitter();
        this.selectRecord = new EventEmitter();
        this.dataTableColumnFormatType = DataTableColumnFormatType;
        this.PAGE_SIZE_OPTIONS = this.displaySizeOptions || [5, 10, 20, 50, 100];
        this.currentPageIndex = 1;
        this.searchControl = new FormControl('');
    }
    ngOnInit() {
        this.i18n.setLocale(en_US);
        this._subscribeToSearchControlChanges();
    }
    ngOnChanges(changes) {
        /** @TODO: check loading status. loading should be input */
        if (changes.records?.currentValue !== 'undefined' ||
            changes.totalRecordsCount?.currentValue !== 'undefined') {
            this.loading = false;
        }
    }
    reset(force = false) {
        if (!force || this.currentPageIndex === 1) {
            this._fetchRecords();
        }
        else {
            this._resetPagination();
        }
    }
    clearSearch() {
        this.searchControl.setValue('');
        this.searchControl.updateValueAndValidity();
    }
    /* Handle Selection Checkboxes */
    updateCheckedSet(id, checked) {
        if (checked) {
            this.selectedRecordsSet.add(id);
        }
        else {
            this.selectedRecordsSet.delete(id);
        }
    }
    onAllChecked(checked) {
        this.records.forEach((rec) => this.updateCheckedSet(rec.id, checked));
        this.selectRecord.emit(this.selectedRecordsSet);
    }
    onItemChecked(id, checked) {
        this.updateCheckedSet(id, checked);
        this.selectRecord.emit(this.selectedRecordsSet);
    }
    onQueryParamsChange(params) {
        const { pageSize, pageIndex } = params;
        this.currentPageIndex = pageIndex;
        this.pageSize = pageSize;
        this._fetchRecords();
    }
    downloadCsv() {
        const header = this.columns.map((col) => col.name);
        const content = this.records.map((record) => {
            return this.columns.map((col) => record[col.field]).join(',');
        });
        const blob = new Blob([[header, ...content].join('\r\n')], { type: 'text/csv' });
        const tag = document.createElement('a');
        tag.href = URL.createObjectURL(blob);
        tag.target = '_blank';
        tag.download = `${this.downloadFileName}.csv`;
        tag.click();
    }
    _subscribeToSearchControlChanges() {
        this.searchControl.valueChanges
            .pipe(debounceTime(300), distinctUntilChanged())
            .subscribe(() => {
            console.log('searchControl.value', this.searchControl.value);
            this.reset(this.currentPageIndex !== 1);
        });
    }
    _resetPagination() {
        this.currentPageIndex = 1;
        this.cdr.markForCheck();
    }
    _fetchRecords() {
        this.loading = true;
        this.fetchRecords.emit({
            searchKey: this.searchControl.value,
            /* @TODO Implement sorting or remove this */
            //sortOrder: this._getSortOrder(),
            //sortField: this.sortedColumn?.field,
            paginationInfo: { pageNumber: this.currentPageIndex, pageSize: this.pageSize },
        });
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DataTableComponent, deps: [{ token: i0.ChangeDetectorRef }, { token: i1$1.NzI18nService }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: DataTableComponent, selector: "x-data-table", inputs: { columns: "columns", records: "records", showDownloadButton: "showDownloadButton", downloadFileName: "downloadFileName", displaySizeOptions: "displaySizeOptions", totalRecordsCount: "totalRecordsCount", pageSize: "pageSize", label: "label", loading: "loading", selectable: "selectable", selectedRecordsSet: "selectedRecordsSet", readonly: "readonly", customCellTemplateRef: "customCellTemplateRef", customNoDataTemplateRef: "customNoDataTemplateRef", searchable: "searchable", width: "width" }, outputs: { fetchRecords: "fetchRecords", selectRecord: "selectRecord" }, usesOnChanges: true, ngImport: i0, template: "<div class=\"x-table-card margin-24px\">\n  <div class=\"x-table-container\">\n    <div class=\"x-table-topbar\">\n      <nz-input-group *ngIf=\"searchable\"\n          class=\"x-table-search-input\"\n          attr.data-testid=\"{{ label + '-table-search' }}\"\n          [nzPrefix]=\"iconSearchTemplate\"\n          [nzSuffix]=\"inputClearTemplate\">\n        <input [formControl]=\"searchControl\"\n            type=\"text\"\n            nz-input\n            placeholder=\"Search...\" />\n      </nz-input-group>\n      <button *ngIf=\"showDownloadButton\"\n          attr.data-testid=\"{{ label + '-record-org-download' }}\"\n          nz-tooltip\n          nzTooltipTitle=\"Download CSV\"\n          nz-button\n          nzType=\"default\"\n          (click)=\"downloadCsv()\">\n        <i nz-icon\n            nzType=\"download\"></i>\n      </button>\n    </div>\n\n    <!-- LOADING -->\n    <div *ngIf=\"loading\"\n        class=\"x-table-spinner\">\n      <nz-spin nzSimple\n          class=\"x-table-spinner-spinning\"\n          [nzIndicator]=\"indicatorTemplate\"></nz-spin>\n      <p>Loading...</p>\n    </div>\n\n    <!-- && searchControl.value === '' && totalRecordsCount === 0 -->\n    <!-- NO DATA -->\n    <div *ngIf=\"!loading && totalRecordsCount === 0\"\n        class=\"x-table-no-data\">\n      <!-- <ng-template #noVehiclesViewTemplate> -->\n      <h3>NO DATA View Add Vehicles</h3>\n      <p>You can either bulk upload or add manually</p>\n      <!-- \n  (click)=\"openBulkUploadModal()\"\n  [disabled]=\"readOnly\" -->\n      <!-- <button nz-button\n            nzType=\"default\"\n            class=\"margin-left-4px margin-right-4px\">\n          <span nz-icon\n              nzType=\"cloud-upload\"\n              nzTheme=\"outline\"></span>\n          Bulk Upload\n        </button> -->\n      <!-- (click)=\"openVehicleEditorModal()\"\n  [disabled]=\"readOnly\" -->\n      <!-- <button nz-button\n            nzType=\"primary\"\n            class=\"margin-left-4px margin-right-4px\">\n          <span nz-icon\n              nzType=\"plus\"></span>\n          Add Manually\n        </button>\n      </ng-template> -->\n\n    </div>\n\n    <div [class.x-table-loading]=\"loading\">\n      <div class=\"x-table\">\n        <nz-table attr.data-testid=\"{{ label + '-table' }}\"\n            #nzTable\n            [nzData]=\"records\"\n            [nzFrontPagination]=\"false\"\n            [nzTotal]=\"totalRecordsCount\"\n            [nzPageIndex]=\"currentPageIndex\"\n            [nzShowTotal]=\"rangeTemplate\"\n            nzShowSizeChanger\n            nzTableLayout=\"fixed\"\n            (nzQueryParams)=\"onQueryParamsChange($event)\">\n          <thead>\n            <tr>\n              <th *ngIf=\"selectable\"\n                  id=\"checkbox-header\"\n                  attr.qa-test-id=\"checkbox-header\"\n                  [nzShowCheckbox]=\"true\"\n                  (nzCheckedChange)=\"onAllChecked($event)\"\n                  [nzWidth]=\"'100px'\"\n                  [ngClass]=\"{'no-pointer': readonly}\"></th>\n              <ng-container *ngFor=\"let column of columns\">\n                <th [nzWidth]=\"column.width\"\n                    [class]=\"column.headerClass\">\n                  <!-- @TODO Implement sorting\n                  [nzSortFn]=\"column.sort\"\n                  [(nzSortOrder)]=\"column.sortOrder\"\n                  (nzSortOrderChange)=\"onSortingChanged(column)\">\n                  -->\n                  {{ column.name }}\n                </th>\n              </ng-container>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr *ngFor=\"let record of nzTable.data\">\n              <td *ngIf=\"selectable\"\n                  attr.qa-test-id=\"{{ 'checkbox-record' + record.id }}\"\n                  [nzChecked]=\"selectedRecordsSet.has(record.id)\"\n                  [nzShowCheckbox]=\"true\"\n                  (nzCheckedChange)=\"onItemChecked(record.id, $event)\"\n                  [ngClass]=\"{'no-pointer': readonly}\"></td>\n              <ng-container *ngFor=\"let column of columns\">\n                <!-- LOOP THROUGH DISPLAYED COLUMNS -->\n                <td [class]=\"column.cellClass\">\n                  <span *ngIf=\"!column.format\">{{ record[column.field] }}</span>\n\n                  <!-- HANDLE SPECIAL FORMATS -->\n                  <!-- As a custom template ref -->\n                  <ng-container *ngIf=\"\n                      customCellTemplateRef &&\n                      column.format?.type === dataTableColumnFormatType.templateRef\n                    \"\n                      [ngTemplateOutlet]=\"customCellTemplateRef\"\n                      [ngTemplateOutletContext]=\"{ column, record }\">\n                  </ng-container>\n\n                  <!-- Or one of most commonly used format type cases -->\n\n                  <x-custom-data-table-cell *ngIf=\"\n                      column.format && column.format?.type !== dataTableColumnFormatType.templateRef\n                    \"\n                      [column]=\"column\"\n                      [record]=\"record\">\n                  </x-custom-data-table-cell>\n                </td>\n              </ng-container>\n            </tr>\n          </tbody>\n        </nz-table>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ng-template #iconSearchTemplate>\n  <i class=\"x-table-search-icon\"\n      nz-icon\n      nzType=\"search\"></i>\n</ng-template>\n<ng-template #inputClearTemplate>\n  <i nz-icon\n      class=\"ant-input-clear-icon\"\n      nzTheme=\"fill\"\n      nzType=\"close-circle\"\n      *ngIf=\"searchControl.value\"\n      (click)=\"clearSearch()\"></i>\n</ng-template>\n\n<ng-template #indicatorTemplate><i nz-icon\n      nzType=\"loading\"></i></ng-template>\n\n<ng-template #rangeTemplate\n    let-range=\"range\"\n    let-total>\n  Showing {{ range[0] }} - {{ range[1] }} of {{ totalRecordsCount }} {{ label }}\n</ng-template>\n", styles: [".x-table-card{background:var(--x-color-neutral-surface);box-shadow:0 0 1px #0000001a,0 1px 3px #0000001f;border-radius:6px}.x-table-container .x-table-topbar{padding:24px;border-bottom:1px solid var(--x-color-border-normal);display:flex;justify-content:space-between}.x-table-container .x-table-topbar .fm-search-input{width:360px}.x-table-container .x-table-topbar .fm-search-input input::placeholder{color:var(--x-color-text-on-surface-subtle);font-style:italic}.x-table-container .x-table-topbar .x-table-search-icon{color:var(--x-color-text-on-surface-subtle);margin-right:6px}.x-table-container .x-table-topbar .x-table-download-button{padding:6px;margin-left:12px}.x-table-container .x-table-topbar .x-table-download-button x-svg-icon{color:var(--x-color-text-on-surface-strong);height:18px;width:18px;line-height:18px}.x-table-container .x-table-topbar .x-table-download-button i{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled x-svg-icon{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled i{display:flex}.x-table-container .x-table{padding:4px 0}.x-table-container .x-table tr{height:80px}.x-table-container .x-table tr>th{padding:24px 16px;background:var(--x-color-background-surface);color:var(--x-color-text-on-surface-strong);font-weight:600;line-height:18px;overflow:auto}.x-table-container .x-table tr>th:before{display:none}.x-table-container .x-table tr>td{padding:12px 16px;color:var(--x-color-text-on-surface-strong)}.x-table-container .x-table tr:hover>td{background-color:var(--x-focus-subtle)!important}.x-table-container .x-table tr td:first-of-type,.x-table-container .x-table tr th:first-of-type{padding-left:24px}.x-table-container .x-table tr td:last-of-type,.x-table-container .x-table tr th:last-of-type{padding-right:24px}.x-table-container .x-table ::ng-deep .ant-table-pagination{padding:8px 24px}.x-table-container .x-table ::ng-deep .ant-table-pagination ul{display:flex;width:100%;justify-content:space-between}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-pagination-total-text{margin-right:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector{box-sizing:border-box!important;min-width:100px;min-height:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector .ant-select-selection-item{margin-top:0!important}.x-table-container .x-table-expandable-icon{display:none}.x-table-container .x-table-number-type{font-size:14px;line-height:22px;color:var(--x-color-text-on-surface-subtle)}.x-table-container .x-table-number-type a{display:block;font-weight:600;color:var(--x-color-text-on-surface-link)}.x-table-container .x-table-number-type a:hover{text-decoration:underline}.x-table-container .x-table-tag{font-size:14px;line-height:18px;padding:3px 8px;background:var(--x-color-system-subtle-grey);border:none}.x-table-loading{display:none}.x-table-spinner{padding:80px;text-align:center}.x-table-spinner .x-table-spinner-spinning i{font-size:48px;color:var(--x-color-primary-main)}.x-table-spinner p{margin:20px 0 0;color:var(--x-color-text-on-surface-subtle);font-weight:400;font-size:16px;line-height:20px}\n"], dependencies: [{ kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet", "ngTemplateOutletInjector"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.FormControlDirective, selector: "[formControl]", inputs: ["formControl", "disabled", "ngModel"], outputs: ["ngModelChange"], exportAs: ["ngForm"] }, { kind: "component", type: i4.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i5.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i6.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "directive", type: i1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }, { kind: "directive", type: i8$1.NzInputDirective, selector: "input[nz-input],textarea[nz-input]", inputs: ["nzBorderless", "nzSize", "nzStepperless", "nzStatus", "disabled"], exportAs: ["nzInput"] }, { kind: "component", type: i8$1.NzInputGroupComponent, selector: "nz-input-group", inputs: ["nzAddOnBeforeIcon", "nzAddOnAfterIcon", "nzPrefixIcon", "nzSuffixIcon", "nzAddOnBefore", "nzAddOnAfter", "nzPrefix", "nzStatus", "nzSuffix", "nzSize", "nzSearch", "nzCompact"], exportAs: ["nzInputGroup"] }, { kind: "directive", type: i8$1.NzInputGroupWhitSuffixOrPrefixDirective, selector: "nz-input-group[nzSuffix], nz-input-group[nzPrefix]" }, { kind: "component", type: i9.NzSpinComponent, selector: "nz-spin", inputs: ["nzIndicator", "nzSize", "nzTip", "nzDelay", "nzSimple", "nzSpinning"], exportAs: ["nzSpin"] }, { kind: "component", type: i10$1.NzTableComponent, selector: "nz-table", inputs: ["nzTableLayout", "nzShowTotal", "nzItemRender", "nzTitle", "nzFooter", "nzNoResult", "nzPageSizeOptions", "nzVirtualItemSize", "nzVirtualMaxBufferPx", "nzVirtualMinBufferPx", "nzVirtualForTrackBy", "nzLoadingDelay", "nzPageIndex", "nzPageSize", "nzTotal", "nzWidthConfig", "nzData", "nzCustomColumn", "nzPaginationPosition", "nzScroll", "nzPaginationType", "nzFrontPagination", "nzTemplateMode", "nzShowPagination", "nzLoading", "nzOuterBordered", "nzLoadingIndicator", "nzBordered", "nzSize", "nzShowSizeChanger", "nzHideOnSinglePage", "nzShowQuickJumper", "nzSimple"], outputs: ["nzPageSizeChange", "nzPageIndexChange", "nzQueryParams", "nzCurrentPageDataChange", "nzCustomColumnChange"], exportAs: ["nzTable"] }, { kind: "directive", type: i10$1.NzTableCellDirective, selector: "th:not(.nz-disable-th):not([mat-cell]), td:not(.nz-disable-td):not([mat-cell])" }, { kind: "directive", type: i10$1.NzThMeasureDirective, selector: "th", inputs: ["nzWidth", "colspan", "colSpan", "rowspan", "rowSpan"] }, { kind: "component", type: i10$1.NzTdAddOnComponent, selector: "td[nzChecked], td[nzDisabled], td[nzIndeterminate], td[nzIndentSize], td[nzExpand], td[nzShowExpand], td[nzShowCheckbox]", inputs: ["nzChecked", "nzDisabled", "nzIndeterminate", "nzIndentSize", "nzShowExpand", "nzShowCheckbox", "nzExpand"], outputs: ["nzCheckedChange", "nzExpandChange"] }, { kind: "component", type: i10$1.NzTheadComponent, selector: "thead:not(.ant-table-thead)", outputs: ["nzSortOrderChange"] }, { kind: "component", type: i10$1.NzTbodyComponent, selector: "tbody" }, { kind: "directive", type: i10$1.NzTrDirective, selector: "tr:not([mat-row]):not([mat-header-row]):not([nz-table-measure-row]):not([nzExpand]):not([nz-table-fixed-row])" }, { kind: "component", type: i10$1.NzThSelectionComponent, selector: "th[nzSelections],th[nzChecked],th[nzShowCheckbox],th[nzShowRowSelection]", inputs: ["nzSelections", "nzChecked", "nzDisabled", "nzIndeterminate", "nzShowCheckbox", "nzShowRowSelection"], outputs: ["nzCheckedChange"] }, { kind: "component", type: CustomDataTableCellComponent, selector: "x-custom-data-table-cell", inputs: ["column", "record"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: DataTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'x-data-table', changeDetection: ChangeDetectionStrategy.OnPush, template: "<div class=\"x-table-card margin-24px\">\n  <div class=\"x-table-container\">\n    <div class=\"x-table-topbar\">\n      <nz-input-group *ngIf=\"searchable\"\n          class=\"x-table-search-input\"\n          attr.data-testid=\"{{ label + '-table-search' }}\"\n          [nzPrefix]=\"iconSearchTemplate\"\n          [nzSuffix]=\"inputClearTemplate\">\n        <input [formControl]=\"searchControl\"\n            type=\"text\"\n            nz-input\n            placeholder=\"Search...\" />\n      </nz-input-group>\n      <button *ngIf=\"showDownloadButton\"\n          attr.data-testid=\"{{ label + '-record-org-download' }}\"\n          nz-tooltip\n          nzTooltipTitle=\"Download CSV\"\n          nz-button\n          nzType=\"default\"\n          (click)=\"downloadCsv()\">\n        <i nz-icon\n            nzType=\"download\"></i>\n      </button>\n    </div>\n\n    <!-- LOADING -->\n    <div *ngIf=\"loading\"\n        class=\"x-table-spinner\">\n      <nz-spin nzSimple\n          class=\"x-table-spinner-spinning\"\n          [nzIndicator]=\"indicatorTemplate\"></nz-spin>\n      <p>Loading...</p>\n    </div>\n\n    <!-- && searchControl.value === '' && totalRecordsCount === 0 -->\n    <!-- NO DATA -->\n    <div *ngIf=\"!loading && totalRecordsCount === 0\"\n        class=\"x-table-no-data\">\n      <!-- <ng-template #noVehiclesViewTemplate> -->\n      <h3>NO DATA View Add Vehicles</h3>\n      <p>You can either bulk upload or add manually</p>\n      <!-- \n  (click)=\"openBulkUploadModal()\"\n  [disabled]=\"readOnly\" -->\n      <!-- <button nz-button\n            nzType=\"default\"\n            class=\"margin-left-4px margin-right-4px\">\n          <span nz-icon\n              nzType=\"cloud-upload\"\n              nzTheme=\"outline\"></span>\n          Bulk Upload\n        </button> -->\n      <!-- (click)=\"openVehicleEditorModal()\"\n  [disabled]=\"readOnly\" -->\n      <!-- <button nz-button\n            nzType=\"primary\"\n            class=\"margin-left-4px margin-right-4px\">\n          <span nz-icon\n              nzType=\"plus\"></span>\n          Add Manually\n        </button>\n      </ng-template> -->\n\n    </div>\n\n    <div [class.x-table-loading]=\"loading\">\n      <div class=\"x-table\">\n        <nz-table attr.data-testid=\"{{ label + '-table' }}\"\n            #nzTable\n            [nzData]=\"records\"\n            [nzFrontPagination]=\"false\"\n            [nzTotal]=\"totalRecordsCount\"\n            [nzPageIndex]=\"currentPageIndex\"\n            [nzShowTotal]=\"rangeTemplate\"\n            nzShowSizeChanger\n            nzTableLayout=\"fixed\"\n            (nzQueryParams)=\"onQueryParamsChange($event)\">\n          <thead>\n            <tr>\n              <th *ngIf=\"selectable\"\n                  id=\"checkbox-header\"\n                  attr.qa-test-id=\"checkbox-header\"\n                  [nzShowCheckbox]=\"true\"\n                  (nzCheckedChange)=\"onAllChecked($event)\"\n                  [nzWidth]=\"'100px'\"\n                  [ngClass]=\"{'no-pointer': readonly}\"></th>\n              <ng-container *ngFor=\"let column of columns\">\n                <th [nzWidth]=\"column.width\"\n                    [class]=\"column.headerClass\">\n                  <!-- @TODO Implement sorting\n                  [nzSortFn]=\"column.sort\"\n                  [(nzSortOrder)]=\"column.sortOrder\"\n                  (nzSortOrderChange)=\"onSortingChanged(column)\">\n                  -->\n                  {{ column.name }}\n                </th>\n              </ng-container>\n            </tr>\n          </thead>\n\n          <tbody>\n            <tr *ngFor=\"let record of nzTable.data\">\n              <td *ngIf=\"selectable\"\n                  attr.qa-test-id=\"{{ 'checkbox-record' + record.id }}\"\n                  [nzChecked]=\"selectedRecordsSet.has(record.id)\"\n                  [nzShowCheckbox]=\"true\"\n                  (nzCheckedChange)=\"onItemChecked(record.id, $event)\"\n                  [ngClass]=\"{'no-pointer': readonly}\"></td>\n              <ng-container *ngFor=\"let column of columns\">\n                <!-- LOOP THROUGH DISPLAYED COLUMNS -->\n                <td [class]=\"column.cellClass\">\n                  <span *ngIf=\"!column.format\">{{ record[column.field] }}</span>\n\n                  <!-- HANDLE SPECIAL FORMATS -->\n                  <!-- As a custom template ref -->\n                  <ng-container *ngIf=\"\n                      customCellTemplateRef &&\n                      column.format?.type === dataTableColumnFormatType.templateRef\n                    \"\n                      [ngTemplateOutlet]=\"customCellTemplateRef\"\n                      [ngTemplateOutletContext]=\"{ column, record }\">\n                  </ng-container>\n\n                  <!-- Or one of most commonly used format type cases -->\n\n                  <x-custom-data-table-cell *ngIf=\"\n                      column.format && column.format?.type !== dataTableColumnFormatType.templateRef\n                    \"\n                      [column]=\"column\"\n                      [record]=\"record\">\n                  </x-custom-data-table-cell>\n                </td>\n              </ng-container>\n            </tr>\n          </tbody>\n        </nz-table>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ng-template #iconSearchTemplate>\n  <i class=\"x-table-search-icon\"\n      nz-icon\n      nzType=\"search\"></i>\n</ng-template>\n<ng-template #inputClearTemplate>\n  <i nz-icon\n      class=\"ant-input-clear-icon\"\n      nzTheme=\"fill\"\n      nzType=\"close-circle\"\n      *ngIf=\"searchControl.value\"\n      (click)=\"clearSearch()\"></i>\n</ng-template>\n\n<ng-template #indicatorTemplate><i nz-icon\n      nzType=\"loading\"></i></ng-template>\n\n<ng-template #rangeTemplate\n    let-range=\"range\"\n    let-total>\n  Showing {{ range[0] }} - {{ range[1] }} of {{ totalRecordsCount }} {{ label }}\n</ng-template>\n", styles: [".x-table-card{background:var(--x-color-neutral-surface);box-shadow:0 0 1px #0000001a,0 1px 3px #0000001f;border-radius:6px}.x-table-container .x-table-topbar{padding:24px;border-bottom:1px solid var(--x-color-border-normal);display:flex;justify-content:space-between}.x-table-container .x-table-topbar .fm-search-input{width:360px}.x-table-container .x-table-topbar .fm-search-input input::placeholder{color:var(--x-color-text-on-surface-subtle);font-style:italic}.x-table-container .x-table-topbar .x-table-search-icon{color:var(--x-color-text-on-surface-subtle);margin-right:6px}.x-table-container .x-table-topbar .x-table-download-button{padding:6px;margin-left:12px}.x-table-container .x-table-topbar .x-table-download-button x-svg-icon{color:var(--x-color-text-on-surface-strong);height:18px;width:18px;line-height:18px}.x-table-container .x-table-topbar .x-table-download-button i{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled x-svg-icon{display:none}.x-table-container .x-table-topbar .x-table-download-button:disabled i{display:flex}.x-table-container .x-table{padding:4px 0}.x-table-container .x-table tr{height:80px}.x-table-container .x-table tr>th{padding:24px 16px;background:var(--x-color-background-surface);color:var(--x-color-text-on-surface-strong);font-weight:600;line-height:18px;overflow:auto}.x-table-container .x-table tr>th:before{display:none}.x-table-container .x-table tr>td{padding:12px 16px;color:var(--x-color-text-on-surface-strong)}.x-table-container .x-table tr:hover>td{background-color:var(--x-focus-subtle)!important}.x-table-container .x-table tr td:first-of-type,.x-table-container .x-table tr th:first-of-type{padding-left:24px}.x-table-container .x-table tr td:last-of-type,.x-table-container .x-table tr th:last-of-type{padding-right:24px}.x-table-container .x-table ::ng-deep .ant-table-pagination{padding:8px 24px}.x-table-container .x-table ::ng-deep .ant-table-pagination ul{display:flex;width:100%;justify-content:space-between}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-pagination-total-text{margin-right:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector{box-sizing:border-box!important;min-width:100px;min-height:auto}.x-table-container .x-table ::ng-deep .ant-table-pagination .ant-select-selector .ant-select-selection-item{margin-top:0!important}.x-table-container .x-table-expandable-icon{display:none}.x-table-container .x-table-number-type{font-size:14px;line-height:22px;color:var(--x-color-text-on-surface-subtle)}.x-table-container .x-table-number-type a{display:block;font-weight:600;color:var(--x-color-text-on-surface-link)}.x-table-container .x-table-number-type a:hover{text-decoration:underline}.x-table-container .x-table-tag{font-size:14px;line-height:18px;padding:3px 8px;background:var(--x-color-system-subtle-grey);border:none}.x-table-loading{display:none}.x-table-spinner{padding:80px;text-align:center}.x-table-spinner .x-table-spinner-spinning i{font-size:48px;color:var(--x-color-primary-main)}.x-table-spinner p{margin:20px 0 0;color:var(--x-color-text-on-surface-subtle);font-weight:400;font-size:16px;line-height:20px}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.ChangeDetectorRef }, { type: i1$1.NzI18nService }]; }, propDecorators: { columns: [{
                type: Input
            }], records: [{
                type: Input
            }], showDownloadButton: [{
                type: Input
            }], downloadFileName: [{
                type: Input
            }], displaySizeOptions: [{
                type: Input
            }], totalRecordsCount: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], label: [{
                type: Input
            }], loading: [{
                type: Input
            }], selectable: [{
                type: Input
            }], selectedRecordsSet: [{
                type: Input
            }], readonly: [{
                type: Input
            }], customCellTemplateRef: [{
                type: Input
            }], customNoDataTemplateRef: [{
                type: Input
            }], searchable: [{
                type: Input
            }], width: [{
                type: Input
            }], fetchRecords: [{
                type: Output
            }], selectRecord: [{
                type: Output
            }] } });

class UmbrellaDataTableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaDataTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaDataTableModule, declarations: [DataTableComponent, CustomDataTableCellComponent], imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            NzButtonModule,
            NzDropDownModule,
            NzGridModule, i1.NzIconModule, NzInputModule,
            NzPaginationModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule], exports: [DataTableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaDataTableModule, imports: [CommonModule,
            FormsModule,
            ReactiveFormsModule,
            NzButtonModule,
            NzDropDownModule,
            NzGridModule,
            NzIconModule.forChild([DownloadOutline]),
            NzInputModule,
            NzPaginationModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaDataTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [DataTableComponent, CustomDataTableCellComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        ReactiveFormsModule,
                        NzButtonModule,
                        NzDropDownModule,
                        NzGridModule,
                        NzIconModule.forChild([DownloadOutline]),
                        NzInputModule,
                        NzPaginationModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                    ],
                    exports: [DataTableComponent],
                }]
        }] });

class HeaderComponent {
    constructor() {
        this.title = '';
        this.subTitle = '';
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: HeaderComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: HeaderComponent, selector: "x-header", inputs: { title: "title", subTitle: "subTitle", tags: "tags", primaryButton: "primaryButton", secondaryButtons: "secondaryButtons", ellipsisDropdownItems: "ellipsisDropdownItems", breadcrumbItems: "breadcrumbItems", navRoutes: "navRoutes" }, ngImport: i0, template: "<nz-page-header class=\"x-header\">\n  <!-- breadcrumbs -->\n  <nz-breadcrumb *ngIf=\"breadcrumbItems?.length\"\n      nzSeparator=\">\"\n      nz-page-header-breadcrumb>\n    <nz-breadcrumb-item *ngFor=\"let breadcrumb of breadcrumbItems\">\n      <a *ngIf=\"breadcrumb.routerLink\"\n          [routerLink]=\"breadcrumb.routerLink\">\n        {{ breadcrumb.name }}\n      </a>\n      <ng-container *ngIf=\"!breadcrumb.routerLink\">{{ breadcrumb.name }}</ng-container>\n    </nz-breadcrumb-item>\n  </nz-breadcrumb>\n\n  <!--title-->\n  <nz-page-header-title>{{ title }}</nz-page-header-title>\n\n  <!--subtitle-->\n  <nz-page-header-subtitle *ngIf=\"subTitle\">{{ subTitle }}</nz-page-header-subtitle>\n\n  <!--tags-->\n  <nz-page-header-tags *ngIf=\"tags?.length\">\n    <nz-tag *ngFor=\"let tag of tags\"\n        nzColor=\"{{ tag?.nzStatusColor || tag?.color }}\">\n      {{ tag?.text }}\n    </nz-tag>\n  </nz-page-header-tags>\n\n  <!-- action buttons and dropdown items-->\n  <nz-page-header-extra>\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\n          nz-button\n          (click)=\"secondaryButton.action()\"\n          class=\"x-header-button-secondary\"\n          [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\"\n            nz-icon\n            [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button *ngIf=\"primaryButton\"\n        nz-button\n        nzType=\"primary\"\n        (click)=\"primaryButton.action()\"\n        class=\"x-header-button-primary\"\n        [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\"\n          nz-icon\n          [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n    <ng-container *ngIf=\"ellipsisDropdownItems?.length\">\n      <button nz-button\n          nzNoAnimation\n          nz-dropdown\n          [nzDropdownMenu]=\"menu\"\n          style=\"border: none; padding: 0\">\n        <i nz-icon\n            nzType=\"ellipsis\"\n            nzTheme=\"outline\"\n            style=\"font-size: 20px; vertical-align: top\"></i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li *ngFor=\"let dropdownItem of ellipsisDropdownItems\"\n              nz-menu-item>\n            {{ dropdownItem.text }}\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </ng-container>\n  </nz-page-header-extra>\n\n  <!-- navigation -->\n  <nz-page-header-content>\n    <ng-content></ng-content>\n    <div *ngIf=\"navRoutes?.length\">\n      <nz-tabset nzLinkRouter>\n        <nz-tab *ngFor=\"let route of navRoutes\">\n          <a [attr.data-testid]=\"route.id\"\n              *nzTabLink\n              nz-tab-link\n              [routerLink]=\"[route.path]\"\n              routerLinkActive=\"active\">\n            {{ route.name }}\n          </a>\n        </nz-tab>\n      </nz-tabset>\n      <ng-template #extraTemplate></ng-template>\n    </div>\n  </nz-page-header-content>\n</nz-page-header>\n", styles: [".x-header{background:#ffffff91;border-bottom:1px solid rgba(0,0,0,.15);padding:24px 24px 0;display:flex;flex-direction:column;position:relative}.x-header:before{content:\"\";background-image:url(/assets/fleet-manager/pattern.svg);background-repeat:no-repeat;background-position:right;width:100%;height:100%;position:absolute;right:0;top:0;opacity:.18;pointer-events:none}.x-header .ant-page-header-heading-title{font-family:Shell;font-weight:600;font-size:32px;line-height:40px;margin-left:20px}.x-header .x-header-button-secondary{margin-right:12px}.ant-tag{border-radius:12px}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$1.RouterLink, selector: "[routerLink]", inputs: ["target", "queryParams", "fragment", "queryParamsHandling", "state", "relativeTo", "preserveFragment", "skipLocationChange", "replaceUrl", "routerLink"] }, { kind: "directive", type: i2$1.RouterLinkActive, selector: "[routerLinkActive]", inputs: ["routerLinkActiveOptions", "ariaCurrentWhenActive", "routerLinkActive"], outputs: ["isActiveChange"], exportAs: ["routerLinkActive"] }, { kind: "component", type: i3$1.NzPageHeaderComponent, selector: "nz-page-header", inputs: ["nzBackIcon", "nzTitle", "nzSubtitle", "nzGhost"], outputs: ["nzBack"], exportAs: ["nzPageHeader"] }, { kind: "directive", type: i3$1.NzPageHeaderTitleDirective, selector: "nz-page-header-title, [nz-page-header-title]", exportAs: ["nzPageHeaderTitle"] }, { kind: "directive", type: i3$1.NzPageHeaderSubtitleDirective, selector: "nz-page-header-subtitle, [nz-page-header-subtitle]", exportAs: ["nzPageHeaderSubtitle"] }, { kind: "directive", type: i3$1.NzPageHeaderContentDirective, selector: "nz-page-header-content, [nz-page-header-content]", exportAs: ["nzPageHeaderContent"] }, { kind: "directive", type: i3$1.NzPageHeaderTagDirective, selector: "nz-page-header-tags, [nz-page-header-tags]", exportAs: ["nzPageHeaderTags"] }, { kind: "directive", type: i3$1.NzPageHeaderExtraDirective, selector: "nz-page-header-extra, [nz-page-header-extra]", exportAs: ["nzPageHeaderExtra"] }, { kind: "directive", type: i3$1.NzPageHeaderBreadcrumbDirective, selector: "nz-breadcrumb[nz-page-header-breadcrumb]", exportAs: ["nzPageHeaderBreadcrumb"] }, { kind: "component", type: i4$1.NzTabSetComponent, selector: "nz-tabset", inputs: ["nzSelectedIndex", "nzTabPosition", "nzTabBarExtraContent", "nzCanDeactivate", "nzAddIcon", "nzTabBarStyle", "nzType", "nzSize", "nzAnimated", "nzTabBarGutter", "nzHideAdd", "nzCentered", "nzHideAll", "nzLinkRouter", "nzLinkExact"], outputs: ["nzSelectChange", "nzSelectedIndexChange", "nzTabListScroll", "nzClose", "nzAdd"], exportAs: ["nzTabset"] }, { kind: "component", type: i4$1.NzTabComponent, selector: "nz-tab", inputs: ["nzTitle", "nzClosable", "nzCloseIcon", "nzDisabled", "nzForceRender"], outputs: ["nzSelect", "nzDeselect", "nzClick", "nzContextmenu"], exportAs: ["nzTab"] }, { kind: "directive", type: i4$1.NzTabLinkDirective, selector: "a[nz-tab-link]", exportAs: ["nzTabLink"] }, { kind: "directive", type: i4$1.NzTabLinkTemplateDirective, selector: "ng-template[nzTabLink]", exportAs: ["nzTabLinkTemplate"] }, { kind: "component", type: i5$1.NzBreadCrumbComponent, selector: "nz-breadcrumb", inputs: ["nzAutoGenerate", "nzSeparator", "nzRouteLabel", "nzRouteLabelFn"], exportAs: ["nzBreadcrumb"] }, { kind: "component", type: i5$1.NzBreadCrumbItemComponent, selector: "nz-breadcrumb-item", inputs: ["nzOverlay"], exportAs: ["nzBreadcrumbItem"] }, { kind: "component", type: i6$1.NzTagComponent, selector: "nz-tag", inputs: ["nzMode", "nzColor", "nzChecked"], outputs: ["nzOnClose", "nzCheckedChange"], exportAs: ["nzTag"] }, { kind: "component", type: i4.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i5.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i6.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "directive", type: i7.NzMenuDirective, selector: "[nz-menu]", inputs: ["nzInlineIndent", "nzTheme", "nzMode", "nzInlineCollapsed", "nzSelectable"], outputs: ["nzClick"], exportAs: ["nzMenu"] }, { kind: "component", type: i7.NzMenuItemComponent, selector: "[nz-menu-item]", inputs: ["nzPaddingLeft", "nzDisabled", "nzSelected", "nzDanger", "nzMatchRouterExact", "nzMatchRouter"], exportAs: ["nzMenuItem"] }, { kind: "directive", type: i8.NzDropDownDirective, selector: "[nz-dropdown]", inputs: ["nzDropdownMenu", "nzTrigger", "nzMatchWidthElement", "nzBackdrop", "nzClickHide", "nzDisabled", "nzVisible", "nzOverlayClassName", "nzOverlayStyle", "nzPlacement"], outputs: ["nzVisibleChange"], exportAs: ["nzDropdown"] }, { kind: "component", type: i8.NzDropdownMenuComponent, selector: "nz-dropdown-menu", exportAs: ["nzDropdownMenu"] }, { kind: "directive", type: i8.NzDropdownButtonDirective, selector: "[nz-button][nz-dropdown]" }, { kind: "directive", type: i1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: HeaderComponent, decorators: [{
            type: Component,
            args: [{ selector: 'x-header', template: "<nz-page-header class=\"x-header\">\n  <!-- breadcrumbs -->\n  <nz-breadcrumb *ngIf=\"breadcrumbItems?.length\"\n      nzSeparator=\">\"\n      nz-page-header-breadcrumb>\n    <nz-breadcrumb-item *ngFor=\"let breadcrumb of breadcrumbItems\">\n      <a *ngIf=\"breadcrumb.routerLink\"\n          [routerLink]=\"breadcrumb.routerLink\">\n        {{ breadcrumb.name }}\n      </a>\n      <ng-container *ngIf=\"!breadcrumb.routerLink\">{{ breadcrumb.name }}</ng-container>\n    </nz-breadcrumb-item>\n  </nz-breadcrumb>\n\n  <!--title-->\n  <nz-page-header-title>{{ title }}</nz-page-header-title>\n\n  <!--subtitle-->\n  <nz-page-header-subtitle *ngIf=\"subTitle\">{{ subTitle }}</nz-page-header-subtitle>\n\n  <!--tags-->\n  <nz-page-header-tags *ngIf=\"tags?.length\">\n    <nz-tag *ngFor=\"let tag of tags\"\n        nzColor=\"{{ tag?.nzStatusColor || tag?.color }}\">\n      {{ tag?.text }}\n    </nz-tag>\n  </nz-page-header-tags>\n\n  <!-- action buttons and dropdown items-->\n  <nz-page-header-extra>\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\n          nz-button\n          (click)=\"secondaryButton.action()\"\n          class=\"x-header-button-secondary\"\n          [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\"\n            nz-icon\n            [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button *ngIf=\"primaryButton\"\n        nz-button\n        nzType=\"primary\"\n        (click)=\"primaryButton.action()\"\n        class=\"x-header-button-primary\"\n        [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\"\n          nz-icon\n          [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n    <ng-container *ngIf=\"ellipsisDropdownItems?.length\">\n      <button nz-button\n          nzNoAnimation\n          nz-dropdown\n          [nzDropdownMenu]=\"menu\"\n          style=\"border: none; padding: 0\">\n        <i nz-icon\n            nzType=\"ellipsis\"\n            nzTheme=\"outline\"\n            style=\"font-size: 20px; vertical-align: top\"></i>\n      </button>\n      <nz-dropdown-menu #menu=\"nzDropdownMenu\">\n        <ul nz-menu>\n          <li *ngFor=\"let dropdownItem of ellipsisDropdownItems\"\n              nz-menu-item>\n            {{ dropdownItem.text }}\n          </li>\n        </ul>\n      </nz-dropdown-menu>\n    </ng-container>\n  </nz-page-header-extra>\n\n  <!-- navigation -->\n  <nz-page-header-content>\n    <ng-content></ng-content>\n    <div *ngIf=\"navRoutes?.length\">\n      <nz-tabset nzLinkRouter>\n        <nz-tab *ngFor=\"let route of navRoutes\">\n          <a [attr.data-testid]=\"route.id\"\n              *nzTabLink\n              nz-tab-link\n              [routerLink]=\"[route.path]\"\n              routerLinkActive=\"active\">\n            {{ route.name }}\n          </a>\n        </nz-tab>\n      </nz-tabset>\n      <ng-template #extraTemplate></ng-template>\n    </div>\n  </nz-page-header-content>\n</nz-page-header>\n", styles: [".x-header{background:#ffffff91;border-bottom:1px solid rgba(0,0,0,.15);padding:24px 24px 0;display:flex;flex-direction:column;position:relative}.x-header:before{content:\"\";background-image:url(/assets/fleet-manager/pattern.svg);background-repeat:no-repeat;background-position:right;width:100%;height:100%;position:absolute;right:0;top:0;opacity:.18;pointer-events:none}.x-header .ant-page-header-heading-title{font-family:Shell;font-weight:600;font-size:32px;line-height:40px;margin-left:20px}.x-header .x-header-button-secondary{margin-right:12px}.ant-tag{border-radius:12px}\n"] }]
        }], propDecorators: { title: [{
                type: Input
            }], subTitle: [{
                type: Input
            }], tags: [{
                type: Input
            }], primaryButton: [{
                type: Input
            }], secondaryButtons: [{
                type: Input
            }], ellipsisDropdownItems: [{
                type: Input
            }], breadcrumbItems: [{
                type: Input
            }], navRoutes: [{
                type: Input
            }] } });

class UmbrellaHeaderModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaHeaderModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaHeaderModule, declarations: [HeaderComponent], imports: [CommonModule,
            RouterModule,
            NzPageHeaderModule,
            NzTabsModule,
            NzBreadCrumbModule,
            NzTagModule,
            NzButtonModule,
            NzDropDownModule,
            NzIconModule], exports: [HeaderComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaHeaderModule, imports: [CommonModule,
            RouterModule,
            NzPageHeaderModule,
            NzTabsModule,
            NzBreadCrumbModule,
            NzTagModule,
            NzButtonModule,
            NzDropDownModule,
            NzIconModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaHeaderModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [HeaderComponent],
                    imports: [
                        CommonModule,
                        RouterModule,
                        NzPageHeaderModule,
                        NzTabsModule,
                        NzBreadCrumbModule,
                        NzTagModule,
                        NzButtonModule,
                        NzDropDownModule,
                        NzIconModule,
                    ],
                    exports: [HeaderComponent],
                }]
        }] });

class FooterComponent {
    constructor() { }
    ngOnInit() { }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.2.12", type: FooterComponent, selector: "x-footer", inputs: { primaryButton: "primaryButton", secondaryButtons: "secondaryButtons" }, ngImport: i0, template: "<div nz-col\n    nzJustify=\"end\">\n  <div nz-row\n      nzJustify=\"end\"\n      class=\"x-footer-logo-container\">\n    <div nz-col\n        class=\"x-footer-logo\"></div>\n  </div>\n  <div *ngIf=\"primaryButton || secondaryButtons\"\n      nz-row\n      nzJustify=\"end\"\n      class=\"x-footer-buttons\">\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\n          nz-button\n          (click)=\"secondaryButton.action()\"\n          [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\"\n            nz-icon\n            [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button *ngIf=\"primaryButton\"\n        nz-button\n        nzType=\"primary\"\n        (click)=\"primaryButton.action()\"\n        [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\"\n          nz-icon\n          [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n  </div>\n</div>\n", styles: [":host{background:var(--x-color-background-base);min-height:40px;bottom:0;position:relative}.x-footer-logo-container{background:var(--x-color-background-base)}.x-footer-logo{background-image:url(/assets/fleet-manager/shell-recharge.svg);background-repeat:no-repeat;background-size:contain;width:140px;min-height:40px;margin:24px 24px 12px 0}.x-footer-buttons{background:#fff;padding:12px}.ant-btn{margin-left:12px!important}\n"], dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i2$2.NzColDirective, selector: "[nz-col],nz-col,nz-form-control,nz-form-label", inputs: ["nzFlex", "nzSpan", "nzOrder", "nzOffset", "nzPush", "nzPull", "nzXs", "nzSm", "nzMd", "nzLg", "nzXl", "nzXXl"], exportAs: ["nzCol"] }, { kind: "directive", type: i2$2.NzRowDirective, selector: "[nz-row],nz-row,nz-form-item", inputs: ["nzAlign", "nzJustify", "nzGutter"], exportAs: ["nzRow"] }, { kind: "component", type: i4.NzButtonComponent, selector: "button[nz-button], a[nz-button]", inputs: ["nzBlock", "nzGhost", "nzSearch", "nzLoading", "nzDanger", "disabled", "tabIndex", "nzType", "nzShape", "nzSize"], exportAs: ["nzButton"] }, { kind: "directive", type: i5.ɵNzTransitionPatchDirective, selector: "[nz-button], nz-button-group, [nz-icon], [nz-menu-item], [nz-submenu], nz-select-top-control, nz-select-placeholder, nz-input-group", inputs: ["hidden"] }, { kind: "directive", type: i6.NzWaveDirective, selector: "[nz-wave],button[nz-button]:not([nzType=\"link\"]):not([nzType=\"text\"])", inputs: ["nzWaveExtraNode"], exportAs: ["nzWave"] }, { kind: "directive", type: i1.NzIconDirective, selector: "[nz-icon]", inputs: ["nzSpin", "nzRotate", "nzType", "nzTheme", "nzTwotoneColor", "nzIconfont"], exportAs: ["nzIcon"] }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: FooterComponent, decorators: [{
            type: Component,
            args: [{ selector: 'x-footer', template: "<div nz-col\n    nzJustify=\"end\">\n  <div nz-row\n      nzJustify=\"end\"\n      class=\"x-footer-logo-container\">\n    <div nz-col\n        class=\"x-footer-logo\"></div>\n  </div>\n  <div *ngIf=\"primaryButton || secondaryButtons\"\n      nz-row\n      nzJustify=\"end\"\n      class=\"x-footer-buttons\">\n    <ng-container *ngIf=\"secondaryButtons?.length\">\n      <button *ngFor=\"let secondaryButton of secondaryButtons\"\n          nz-button\n          (click)=\"secondaryButton.action()\"\n          [disabled]=\"secondaryButton.disabled\">\n        <i *ngIf=\"secondaryButton.nzIconName\"\n            nz-icon\n            [nzType]=\"secondaryButton.nzIconName\"></i>\n        {{ secondaryButton.text }}\n      </button>\n    </ng-container>\n    <button *ngIf=\"primaryButton\"\n        nz-button\n        nzType=\"primary\"\n        (click)=\"primaryButton.action()\"\n        [disabled]=\"primaryButton.disabled\">\n      <i *ngIf=\"primaryButton.nzIconName\"\n          nz-icon\n          [nzType]=\"primaryButton.nzIconName\"></i>\n      {{ primaryButton?.text }}\n    </button>\n  </div>\n</div>\n", styles: [":host{background:var(--x-color-background-base);min-height:40px;bottom:0;position:relative}.x-footer-logo-container{background:var(--x-color-background-base)}.x-footer-logo{background-image:url(/assets/fleet-manager/shell-recharge.svg);background-repeat:no-repeat;background-size:contain;width:140px;min-height:40px;margin:24px 24px 12px 0}.x-footer-buttons{background:#fff;padding:12px}.ant-btn{margin-left:12px!important}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { primaryButton: [{
                type: Input
            }], secondaryButtons: [{
                type: Input
            }] } });

class UmbrellaFooterModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaFooterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaFooterModule, declarations: [FooterComponent], imports: [CommonModule, NzGridModule, NzButtonModule, NzIconModule], exports: [FooterComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaFooterModule, imports: [CommonModule, NzGridModule, NzButtonModule, NzIconModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaFooterModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [FooterComponent],
                    imports: [CommonModule, NzGridModule, NzButtonModule, NzIconModule],
                    exports: [FooterComponent],
                }]
        }] });

/* Ant icon definitions */
const icons = [EditOutline, PlusOutline, DeleteOutline, WarningOutline];
class UmbrellaLibraryModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryModule, declarations: [UmbrellaLibraryComponent], imports: [
            /* Angular Modules */
            CommonModule,
            ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            NzAnchorModule,
            NzBreadCrumbModule,
            NzButtonModule,
            NzCardModule,
            NzCascaderModule,
            NzCollapseModule,
            NzDividerModule,
            NzDrawerModule,
            NzFormModule,
            NzGridModule,
            NzIconModule, i1.NzIconModule, NzInputModule,
            NzInputNumberModule,
            NzMessageModule,
            NzModalModule,
            NzPageHeaderModule,
            NzPaginationModule,
            NzRadioModule,
            NzResultModule,
            NzSelectModule,
            NzSpaceModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
            NzTabsModule,
            NzTagModule,
            NzToolTipModule,
            NzTypographyModule], exports: [
            /* Angular Modules */
            CommonModule,
            ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            NzAnchorModule,
            NzBreadCrumbModule,
            NzButtonModule,
            NzCardModule,
            NzCascaderModule,
            NzCollapseModule,
            NzDividerModule,
            NzDrawerModule,
            NzFormModule,
            NzGridModule,
            NzIconModule,
            NzInputModule,
            NzInputNumberModule,
            NzMessageModule,
            NzModalModule,
            NzPageHeaderModule,
            NzPaginationModule,
            NzRadioModule,
            NzResultModule,
            NzSelectModule,
            NzSpaceModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
            NzTabsModule,
            NzTagModule,
            NzToolTipModule,
            NzTypographyModule] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryModule, imports: [
            /* Angular Modules */
            CommonModule,
            ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            NzAnchorModule,
            NzBreadCrumbModule,
            NzButtonModule,
            NzCardModule,
            NzCascaderModule,
            NzCollapseModule,
            NzDividerModule,
            NzDrawerModule,
            NzFormModule,
            NzGridModule,
            NzIconModule,
            NzIconModule.forChild(icons),
            NzInputModule,
            NzInputNumberModule,
            NzMessageModule,
            NzModalModule,
            NzPageHeaderModule,
            NzPaginationModule,
            NzRadioModule,
            NzResultModule,
            NzSelectModule,
            NzSpaceModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
            NzTabsModule,
            NzTagModule,
            NzToolTipModule,
            NzTypographyModule, 
            /* Angular Modules */
            CommonModule,
            ReactiveFormsModule,
            /* Umbrella Modules */
            UmbrellaHeaderModule,
            UmbrellaFooterModule,
            UmbrellaDataTableModule,
            /* Ant Modules */
            NzAnchorModule,
            NzBreadCrumbModule,
            NzButtonModule,
            NzCardModule,
            NzCascaderModule,
            NzCollapseModule,
            NzDividerModule,
            NzDrawerModule,
            NzFormModule,
            NzGridModule,
            NzIconModule,
            NzInputModule,
            NzInputNumberModule,
            NzMessageModule,
            NzModalModule,
            NzPageHeaderModule,
            NzPaginationModule,
            NzRadioModule,
            NzResultModule,
            NzSelectModule,
            NzSpaceModule,
            NzSpinModule,
            NzSwitchModule,
            NzTableModule,
            NzTabsModule,
            NzTagModule,
            NzToolTipModule,
            NzTypographyModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaLibraryModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [UmbrellaLibraryComponent],
                    imports: [
                        /* Angular Modules */
                        CommonModule,
                        ReactiveFormsModule,
                        /* Umbrella Modules */
                        UmbrellaHeaderModule,
                        UmbrellaFooterModule,
                        UmbrellaDataTableModule,
                        /* Ant Modules */
                        NzAnchorModule,
                        NzBreadCrumbModule,
                        NzButtonModule,
                        NzCardModule,
                        NzCascaderModule,
                        NzCollapseModule,
                        NzDividerModule,
                        NzDrawerModule,
                        NzFormModule,
                        NzGridModule,
                        NzIconModule,
                        NzIconModule.forChild(icons),
                        NzInputModule,
                        NzInputNumberModule,
                        NzMessageModule,
                        NzModalModule,
                        NzPageHeaderModule,
                        NzPaginationModule,
                        NzRadioModule,
                        NzResultModule,
                        NzSelectModule,
                        NzSpaceModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                        NzTabsModule,
                        NzTagModule,
                        NzToolTipModule,
                        NzTypographyModule,
                    ],
                    exports: [
                        /* Angular Modules */
                        CommonModule,
                        ReactiveFormsModule,
                        /* Umbrella Modules */
                        UmbrellaHeaderModule,
                        UmbrellaFooterModule,
                        UmbrellaDataTableModule,
                        /* Ant Modules */
                        NzAnchorModule,
                        NzBreadCrumbModule,
                        NzButtonModule,
                        NzCardModule,
                        NzCascaderModule,
                        NzCollapseModule,
                        NzDividerModule,
                        NzDrawerModule,
                        NzFormModule,
                        NzGridModule,
                        NzIconModule,
                        NzInputModule,
                        NzInputNumberModule,
                        NzMessageModule,
                        NzModalModule,
                        NzPageHeaderModule,
                        NzPaginationModule,
                        NzRadioModule,
                        NzResultModule,
                        NzSelectModule,
                        NzSpaceModule,
                        NzSpinModule,
                        NzSwitchModule,
                        NzTableModule,
                        NzTabsModule,
                        NzTagModule,
                        NzToolTipModule,
                        NzTypographyModule,
                    ],
                }]
        }] });

class UmbrellaErrorInterceptor {
    constructor() {
        this.isLocalHost = () => window.location.href.includes('localhost:4000');
    }
    intercept(request, next) {
        return next.handle(request).pipe(tap(() => { }, (error) => {
            /* Catch any 401 Unauthorized API errors, and log out user */
            if (error instanceof HttpErrorResponse) {
                console.error('[UmbrellaErrorInterceptor]', error);
                if (error.status === 401) {
                    setTimeout(() => this.logoutViaUmbrellaForm(), 3000);
                }
            }
        }));
    }
    /* Log user out if the MFE is running inside the Umbrella and not on localhost */
    logoutViaUmbrellaForm() {
        const form = document.getElementById('u-logoutForm');
        if (form && !this.isLocalHost()) {
            form.submit();
        }
        else {
            console.error('[UmbrellaErrorInterceptor] Automated log out failed. Either user is on localhost or logout form not found.');
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaErrorInterceptor, deps: [], target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaErrorInterceptor }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.2.12", ngImport: i0, type: UmbrellaErrorInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

/*
 * Public API Surface of umbrella-library
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DataTableColumnFormatType, DataTableComponent, FooterComponent, HeaderComponent, ResponseStatus, UmbrellaDataTableModule, UmbrellaErrorInterceptor, UmbrellaFooterModule, UmbrellaHeaderModule, UmbrellaLibraryComponent, UmbrellaLibraryModule, UmbrellaLibraryService };
//# sourceMappingURL=umbrella-library.mjs.map
