import { UmbrellaLibraryService } from '../../../umbrella-library.service';
import { ChangeDetectorRef } from '@angular/core';
import { DataTableColumn, DataTableColumnFormatType } from '../data-table.model';
import { getNestedAttribute } from '../data-table.utils';
import * as i0 from "@angular/core";
export declare class CustomDataTableCellComponent {
    private cdr;
    private library;
    column: DataTableColumn;
    record: any;
    readonly dataTableColumnFormatType: typeof DataTableColumnFormatType;
    readonly getNestedAttribute: typeof getNestedAttribute;
    loadingStatusToggleRecordId: number;
    constructor(cdr: ChangeDetectorRef, library: UmbrellaLibraryService);
    onStatusToggleClick(event: MouseEvent, column: DataTableColumn, record: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CustomDataTableCellComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CustomDataTableCellComponent, "x-custom-data-table-cell", never, { "column": { "alias": "column"; "required": false; }; "record": { "alias": "record"; "required": false; }; }, {}, never, never, false, never>;
}
